"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DirectoryStore = void 0;
const path = require("path");
class DirectoryStore {
    store;
    constructor() {
        this.store = new Map();
    }
    consumeImports(props) {
        for (const list of props.lists) {
            for (const name of list) {
                const filePath = path.join(props.directory, name);
                if (!props.exclude.includes(filePath)) {
                    this.store.set(name, path.dirname(filePath));
                }
            }
        }
    }
    getDirectory(chunk, exclude) {
        if (chunk.facadeModuleId) {
            this.store.set(chunk.fileName, path.dirname(chunk.facadeModuleId));
        }
        const directory = this.store.get(chunk.fileName);
        if (!directory) {
            throw new Error(`Unresolvable: ${chunk.fileName}`);
        }
        this.consumeImports({ directory, exclude, lists: [chunk.imports, chunk.dynamicImports] });
        return directory;
    }
}
exports.DirectoryStore = DirectoryStore;
